import processing.core.*; 
import processing.xml.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class igtmqueuejam extends PApplet {


//images
PImage[] images;
PFont font;

int score = 0;
int amountToReduce = 2;

boolean isDownThisFrame = false;
int lastFrameAnimation = 0;
int typedRecently = 0;

ArrayList targets;
int targetradius = 10;

int multiplier = 1;

int power1 = 0;
//int power2 = 0;

int numpics;


public void setup()
{
    size(1024, 485);
    frameRate(30);
    
    //load images needed
    images = new PImage[10];
    //background
    images[0] = loadImage("background.png");
    
    //obnoxious clip art
    images[1] = loadImage("gallery-58832p1.jpg");
    images[2] = loadImage("cat.jpg");
    images[3] = loadImage("pic.jpg");
    images[4] = loadImage("pic.png");

    numpics = 4;
    
    for(int i = 1; i < numpics + 1; i++)
    {
      images[i].resize(0, 200);
    }
    
    //font
    font = loadFont("PMingLiU-30.vlw"); 
    
    //initialize
    score = 0;
    
    //make target list
    targets = new ArrayList();
    
}

public void drawPower()
{
  //left
  if(power1 > 0)
  {
    image(images[((power1 - 1) % numpics) + 1], 150, 50);
    image(images[((power1 - 1) % numpics) + 1], 750, 50);
  }
}

public void draw()
{
  //draw background
  image(images[0], 0, 0);
  drawPower();
  
  drawScore();
  drawSpeaker();
  
  makeTargets();
  
  

  reduceScore();
}

public void makeTargets()
{
  if(targets.size() < 5)
  {
    PVector vec = new PVector(random(width - 50) + 25, random(height - 50) + 25);
    targets.add(vec);
  }
  for(int i = targets.size() - 1; i >= 0; i--)
  {
    ((PVector)targets.get(i)).x -= 2;
    if(((PVector)targets.get(i)).x < 0)
    {
      targets.remove(i);
    }
    else
    {
      fill(random(255), random(255), random(255));
      ellipseMode(RADIUS);
      ellipse(((PVector)targets.get(i)).x, ((PVector)targets.get(i)).y, targetradius, targetradius);
    }
  }
}


public void drawSpeaker()
{
  PVector loc = new PVector(width/2, height/2 - 50);
  
  fill(255, 175, 46);
  ellipseMode(CENTER);
  ellipse(loc.x, loc.y, 25, 25);
  fill(82, 78, 59);
  ellipseMode(CORNER);
  ellipse(loc.x -10, loc.y + 12.5f, 20, 70);
  
  int maxheight = (int)(height * (score / 2000.0f));
  fill(165, 47, 27);
  noStroke();
  int hei;
  if(typedRecently > 0 && lastFrameAnimation == 0)
  {
    hei = (int)maxheight;
    lastFrameAnimation = 1;
  }
  else
  {
    hei = 1;
    lastFrameAnimation = 0;
  }
  rect(loc.x - 5, loc.y + 5, 10, hei);
}

public void drawScore()
{
  fill(226, 255, 113);
  textFont(font);
  textAlign(LEFT);
  text("SCORE: " + score, 15, 30);
  
  fill(255, 0, 0);
  textAlign(CENTER);
  text("PRESS KEYS TO BLAB ..--..--.. CLICK TARGETS TO ADVANCE SLIDES", 
       0, height - 50, width, 200);
}

public void reduceScore()
{
  if(!isDownThisFrame)
  {
    score = (score - amountToReduce*multiplier < 0 ? 0 : score - amountToReduce*multiplier);
    typedRecently -= 1;
  }
  isDownThisFrame = false;
}

public void mouseReleased() 
{
  //find if it's in the circles
  for(int i = targets.size() - 1; i >= 0; i --)
  {
    PVector cur = (PVector)targets.get(i);
    if((pow(cur.x - mouseX, 2) + pow(cur.y - mouseY, 2)) < pow(targetradius, 2))
    {
      multiplier += 1;
      targets.remove(i);
      power1 += 1;
    }
  }
}

public void keyReleased()
{
  score += 5 * multiplier;
  isDownThisFrame = true;
  typedRecently = 5;
}
  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#F0F0F0", "igtmqueuejam" });
  }
}
